/**
 * index.js
 *
 * If you need this component, import the default exports
 * in this file. It gives you a reference for everything
 * needed to interact with it.
 **/

import * as constants from './constants'
import { actions, reducer } from './state'
import * as components from './components'
// import { createSelector } from 'reselect'
// import { NAME } from './constants'
// import _ from 'lodash'

const filters = {
  all: projects => projects.filter(p => projects.active)
}

const selectors = {
  getAll: state => state[constants.NAME],
  getActive: () => []
}

/* export const getAll = state => state[NAME]
export const getActive = _.compose(filterActive, getAll)
export const getCounts = createSelector(
    getAll,
    getActive,
    (allProjects, activeProjects) => ({
      all: allProjects.length,
      active: activeProjects.length
    })
) */

const bitfield = {
  name: '',
  description: '',
  nrOfRegisters: 0,
  bitsPerRegister: 0,
  modes: []
}

const setting = {
  name: '',
  description: '',
  nrOfBits: 0,
  bitMap: [],
  comment: '',
  synonyms: [],
  resetValue: 0,
  defaultValues: []
}

export default { actions, constants, components, filters, selectors, reducer }
