import React from 'react'
import ReactDOM from 'react-dom'
import { browserHistory, Router, Route, IndexRedirect } from 'react-router'
import { createStore, combineReducers, compose } from 'redux'
import { Provider } from 'react-redux'
import { syncHistoryWithStore, routerReducer } from 'react-router-redux'

import App from './App'
import project from './project'
import './index.css'

console.log(project)

/**
 * Redux Section
 **/
const rootReducer = combineReducers({
  projects: project.reducer,
  routing: routerReducer
})

const defaultState = {
  projects: project.state
}

const enhancers = compose(
    window.devToolsExtension ? window.devToolsExtension() : f => f
)

const store = createStore(rootReducer, defaultState, enhancers)
const history = syncHistoryWithStore(browserHistory, store)

/**
 * React-Router Section
 **/
const router = (
  <Provider store={store}>
    <Router history={history}>
      <Route path='/' component={App}>
        <IndexRedirect to='project' />
        <Route path='project' component={project.components.EditProject} />
      </Route>
    </Router>
  </Provider>
)

/**
 * Render the app
 **/
ReactDOM.render(
  router,
  document.getElementById('root')
)
